MOL2DAT(1)            Utility Commands                  MOL2DAT(1)

NAME
     mol2dat - converts VAMP .mol-files into CHEMVIEW .dat-files

SYNOPSIS
     mol2dat [file]

DESCRIPTION
       mol2dat converts .mol-files (which are generated by
     the semi-empiric molecule calculator VAMP or by cascade)
     into .dat-files, which can be used by Chemview to
     generate a rotating (calotte) image of the molecule.
       This is done via an awk-script. (For information about awk see
     the documentation in the gawk directory)

REQUIRED FILES
       You need awk on your system. To create .mol-files you need
     one of the following:
     1. the program VAMP.
     2. the program AMPAC and pac2mol (of cascade)
     3. the program MOPAC and pac2mol (of cascade)

INSTALLATION
     Put awk.exe, mol2dat.bat on your path and mol2dat.awk
     in the directory specified in mol2dat.bat.

EXAMPLES
       Let's say there is a file h2o.mol in your mol2dat directory
     Simply type:
     
	mol2dat h2o 
     
     and there should be a h2o.dat file in your current directory.
     This can be viewed using Chemview, part of the Chemical package.

REQUIRED FILES
       For running the program, you need:
     awk.exe, mol2dat.bat (preferably on the path)
     mol2dat.awk (in the directory specified in mol2dat.bat)
     mol2dat.man (wherever you like it)
     
COPYRIGHT     
     See the file COPYING

BUGS
       A possible problem may be the coloring of the atoms. (It's not a bug,
     it's a feature.) They are colored as follows:

      atom:      color:
	H       white
	F       light green
	Cl      dark green
	Br      light cyan
	I       dark cyan
	O       red
	S       yellow
	N       dark blue
	P       pink
	Si      light grey
	B       light blue
	Li      dark violet
	Mg      light violet
	C       dark grey
     metals     brown

     By the way, this scheme is a generalisation of the CPK colour
     scheme, which in turn is based upon the colours of the
     popular plastic spacefilling models which were developed by
     Corey, Pauling and later improved by Kultun and is
     the scheme conventionally used by chemists.

       If you have problems with these ugly colors,
     you can still change the file atoms.dec. :-)

RELATED PROGRAMS
       Chemview is a part of Chemical, which is available via anonymous 
     FTP at SimTel and his mirrors.

     MOPAC/AMPAC are available via anonymous FTP at:
	ftp://kekule.osc.edu/pub/chemistry

AUTHORS (i.e. send bug reports to)
     Michael Reichenb"acher (AWK-programming)
     reichenb@mi.uni-erlangen.de

     Ralph Puchta (chemical supervision / color choice)
     puchta@anorganik.chemie.uni-erlangen.de
